<?php defined('SYSPATH') or die('No direct script access.');

class SortingOptions { //extends SplEnum {
    //const __default = self::Name;

    const Name = 0;
    const Grade = 1;
    const Group = 2;
}

class Controller_Handler_AdmStudents extends Controller_Handler {
        
        public function before() {
            $this->model = new Model_Admin_Students();
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }

        public function action_createStudent()
        {
            $response['success'] = false;
            $this->post
                    ->rule('firstName', 'not_empty')
                    // ->rule('firstName', 'alpha_dash', array(':value', TRUE))
                    // ->rule('secondName', 'not_empty')
                    // ->rule('secondName', 'alpha_dash', array(':value', TRUE))
                    ->rule('lastName', 'not_empty')
                    // ->rule('lastName', 'alpha_dash', array(':value', TRUE))
                    ->rule('gradeNum', 'not_empty')
                    ->rule('gradeNum', 'digit')
                    ->rule('groupNum', 'not_empty')
                    ->rule('groupNum', 'digit')
                    ->rule('facultyID', 'not_empty')
                    ->rule('facultyID', 'digit');
            if($this->post->offsetGet('gradeNum') == 0)
            {
                $this->post->error('gradeNum', 'not_empty');
                $response['success'] = false;
            }
            if($this->post->offsetGet('groupNum') == 0)
            {
                $this->post->error('groupNum', 'not_empty');
                $response['success'] = false;
            }
            if($this->post->offsetGet('facultyID') == 0)
            {
                $this->post->error('facultyID', 'not_empty');
                $response['success'] = false;
            }
            if($this->post->check())
            {
                $code = $this->_createStudent(
                        $this->post->offsetGet('lastName'),
                        $this->post->offsetGet('firstName'),
                        $this->post->offsetGet('secondName'),
                        $this->post->offsetGet('gradeNum'),
                        $this->post->offsetGet('groupNum'),
                        $this->post->offsetGet('facultyID'));
                if($code != -1)
                {
                    $response['success'] = true;
                    $response['code'] = $code;
                }
                else {
                    $response['success'] = false;
                }
            }
            else
            {
                $response['success'] = false;
                $response['messages'] = $this->post->errors();
            }
            $this->response->body(json_encode($response));
        }
        
        public function action_uploadStudentFile()
        {
            $this->model->getStudentFile();
            
        }
        
        protected function _createStudent($lastName, $firstName, $secondName, $gradeID, $groupNum, $facultyID)
        {
            $activationCode = Account::instance()->createStudent($lastName, $firstName, $secondName, $gradeID, $groupNum, $facultyID);
            return $activationCode;
        }
        
        public function action_getStudyGroups()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $gradeID = $this->post->offsetGet('gradeNum');
            if(($facultyID && $gradeID) != 0)
            {
                $studyGroups = $this->model->getStudyGroups($gradeID, $facultyID);
                $studyGroupsHandled = array(); $i = $j = $id = 0;
                foreach($studyGroups as $row)
                {
                    if($id != $row['SpecID'])
                    {
                        $i++; $j = 0;
                        $id = $row['SpecID'];
                    }
                    $j++;
                    if (is_null($row['SpecName'])) 
                    	$studyGroupsHandled[$i]['SpecName'] = "<без специализации>";
                    else
                    	$studyGroupsHandled[$i]['SpecName'] = $row['SpecName'];
                    $studyGroupsHandled[$i]['Groups'][$j]['ID'] = $row['ID'];
                    $studyGroupsHandled[$i]['Groups'][$j]['Num'] = $row['GroupNum'];
                }
                $this->response->body(json_encode($studyGroupsHandled));
            }
        }

        public function action_getStudentsList($option = SortingOptions::Name)
        {
            $success = false;
            $facultyID = $this->post->offsetGet('facultyID');
            $gradeID = $this->post->offsetGet('gradeID');
            $groupID = $this->post->offsetGet('groupID');

            $this->post-> rule('FacultyID', 'not_empty')
                -> rule('facultyID', 'digit')
                -> rule('GradeID', 'not_empty')
                -> rule('gradeID', 'digit')
                -> rule('GroupID', 'not_empty')
                -> rule('groupID', 'digit');
            if($this->post->check()) {
//                $result = $this->commonModel->GetStudentsList($this->user['UserID'], $facultyID , $gradeID, $groupID);
                $result = DataArray::factory('Students')->byFaculty($facultyID , $gradeID, $groupID)->asArray();
                if (!empty($result)) {
                    $success = true;
                }

            }
            //$this->response->body(json_encode($data));
            $twig = Twig::factory('admin/students/handler/listOutput');
            $twig->List = $result;
            $twig->Success = $success;
            $this->response->body($twig);
        }

        public function action_getStudentsByGrade()
        {
            $gradeID = $this->post->offsetGet('gradeID');
            if($gradeID != 0)
            {
                $twig = Twig::factory('admin/students/handler/listOutput');
                $twig->List = DataArray::factory('Students')->byGrade($gradeID)->asArray();
                $this->response->body($twig);           
            }
        }
        
        public function action_getStudentsByStudyGroup()
        {
            $groupID = $this->post->offsetGet('studyGroupID');
            if($groupID != 0)
            {
                $twig = Twig::factory('admin/students/handler/listOutput');
                $twig->List = DataArray::factory('Students')->byStudyGroup($groupID)->asArray();
                $this->response->body($twig);           
            }
        }
        
        public function action_getStudentsByFaculty()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            if($facultyID != 0)
            {
                $twig = Twig::factory('admin/students/handler/listOutput');
                $twig->List = DataArray::factory('Students')->byFaculty($facultyID)->asArray();
                $this->response->body($twig);           
            }
        }
        
}